define(['config', 'jquery', 'ajax_queue', 'storage', 'filterable-list', 'mixins', 'utils', 'throttle-debounce'], function(ECMWF, $, Ajaxqueue, localStorage, List, Mixins){

	var settings = {
		cache_expire_mins: ECMWF.options.thumbnail_cache || 10
	}

	var mixins = {
		validate: function(tests) {
			for(var t in tests) if(!tests[t][1]()){
				var message = tests[t][0];
				console.warn('validate: "' + message + '" failed.');
				this.error_msg = "test '" + message + "' failed";
				return false;
			}
			return true;
		}
	}

	function Collection(){
	}
	Collection.prototype = $.extend(new List(), mixins, {bind: Mixins.bind}, {
		set_package: function(pkg){
			this._products = null;
			this._facets = null;
			$.extend(this.query, {package: pkg})
		},

		set_list: function(){
			var self = this;
			this.products().then(function(items){
				self.on_load(items)
			})
		},

		product_by_name: function(name) {
			for(var i in this._products){
				if(this._products[i].data.name === name) return this._products[i];
			}
		},

		/*
		 *  Get html text content associated with the given product or category.
		 */
		content: function(product_name, done) {
			Ajaxqueue({
				url: '/plots/get-product-text/',
				json: {product: {name: product_name}},
				success: done
			});
		},

		cancel_thumbnails: function() {
			//Ajaxqueue.cancelByTag(new RegExp(self.eventNamespace + '$')); - does not work when batching requests
			this._cancel_warning_done || console.log('products.cancel_thumbnails TODO');
			this._cancel_warning_done = true;
		}
	})

	return Collection
})

