define(['config', 'jquery', 'bus', 'ajax_queue', './reporter', 'settings', 'chart/plugins/resize', 'unit', 'thumbnail-list', 'messages', 'chart', 'chart/plugins/marker', 'chart/plugins/save', 'toolbar', 'toolbar/extended.css', 'time-navigator', 'product_manager', 'shortcuts', 'tooltip/tipsy', 'meteograms', 'focusable', 'ajax-indicator', 'chart/latlon', './forecaster.css', './application.css'], function(ECMWF, $, Bus, Ajaxqueue, Reporter, Settings, resize) {

var old_template;

$.when(Settings.schema, Settings.data).then(function(){
	if (!ECMWF.request.kiosk) {
		$.fn.keyboard = function() {
			return this;
		}
	}

	window.Workspaces && Workspaces.init();

	// TODO need these actions
	/*
	var product_thumbnail_dialogue_options = {
		text: 'Select from these ECMWF Products to add to your personal list',
		actions: [{
			name: 'Add to product list',
			on_click: function(item) {
				//$('#products').thumbnailDialogue('hideByName', item);
				Bus().send('product-dialogue-selection', {
					names: [item]
				});
			}
		},
		{
			name: 'View in map',
			on_click: function(item) {
				Bus().send('product-thumbnail-click', {
					name: item
				});
			}
		}],
		hide_user_items: true
	};

	var projection_thumbnail_dialogue_options = {
		text: 'Select from these ECMWF Projections to add to your personal list',
		kind: 'projection',
		actions: [{
			name: 'Add to projection list',
			on_click: function(item) {
				//$('#projections').thumbnailDialogue('hideByName', item);
				Bus().send('projection-dialogue-selection', {
					names: [item]
				});
			}
		},
		{
			name: 'Apply to map',
			on_click: function(item) {
				Bus().send('projection-thumbnail-click', {
					name: item
				});
			}
		}],
		hide_user_items: true
	};
	*/

	$(function(){
		ECMWF.wheelspeed = ECMWF.browser.mozilla ? 10 : 1;
		old_template = !$('#app-menu').length;

		$.fn.workspaceMenu && $('#menu-bar').workspaceMenu({menu: new ECMWF.MenuBar('#menu-bar', 'menu-panes'), position: 5});

      load_chart(function(_chart){
			chart = _chart;

			(chart && chart.create()) || ECMWF.alert({
				title: 'Chart not found',
				content: (
					ECMWF.request.widget
					? 'Cannot find widget "<b>' + $('<span>').text(ECMWF.request.widget).text() + '</b>"'
					: 'Chart not found: ' + $('#chart').chart('option', 'product')
				)
			});
		});

		// These are very slow and cause a lot of rerendering so execution is delayed
		var fns = [
			function(){
				ECMWF.browser.supports_svg_img(function(supported) {
					if(!supported) {
						console.warn('svg-image NOT supported');
						// see widgets/chart/plugins/svg_image.js for better implementation
						if(Settings.get_pref('image_format') === 'svg'){
							ECMWF.alert({
								title:   'SVG Not Supported',
								content: '<b>This browser does not support SVG images.</b><p style="margin-top:1em;">Please go to Help / Preferences and change Image Format to PNG.</p>'
							});
						}
					}
				});
			},
			function(){
				$('#products').thumbnailList({
					kind: 'product',
					visible_items: 6,
					show_add_button: function () {
						if(false)
							$('#products').thumbnailDialogue(product_thumbnail_dialogue_options);
						else
							open_dialogue('product')
					}
				});
				$('#projections').thumbnailList({
					kind: 'projection',
					visible_items: 6,
					show_add_button: function () {
						if(false)
							$('#projections').thumbnailDialogue(projection_thumbnail_dialogue_options);
						else
							open_dialogue('projection')
					}
				});

				$('#views, #save, #test').menuList();
				$('#go').menuList().find('li:first').removeClass('enabled').addClass('disabled');
				$('#messages').messages();
				//$("#timers").timersInfo();
				//$("#notifications").notifications({ counter: $("#notifications-counter")});
				require(['data-availability'], function() {
					$('#availability').dataAvailability({
						counter: $('#availability-counter')
					})
				})
			},
			function(){
				// Create all menus
				require(['menu_pane'], function() {
					var menus = ['products', 'projections', 'views', 'save', 'availability', 'test', 'go'];
					for (var i in menus) {
						$('#' + menus[i] + '-menu').addClass('fff').button({icons: {secondary: 'ui-icon-triangle-1-s'}});

						$('#' + menus[i] + '-pane').menuPane({
							group: '#menu-panes > div',
							owner: $('#' + menus[i] + '-menu')
						});

						// When a thumbnail is selected, close the menu
						(function (menu) {
							$('#' + menu).on('select', function () {
								$('#' + menu + "-pane").trigger('close');
								return false;
							});
						})(menus[i]);
					}

					var fs = {
						button: $('#menu-bar').li('.menu-item').text('Fullscreen').button({iconPosition: 'end'}).click(function(){
							$('#status-bar-outer, header').toggle();
							fs.handlers[fs.i++ % 2]();
							$('body').triggerHandler('layout');
						}),
						handlers: [
							function() {
								$('#main').addClass('fullsize');
								fs.button.button('option', 'icons', {primary: 'ui-icon-arrow-2-ne-sw'});
							},
							function() {
								console.log('2');
								$('#main').removeClass('fullsize');
								fs.button.button('option', 'icons', {primary: 'ui-icon-arrow-4-diag'});
							}
						],
						i: 0
					}
				})
			},
			/* fs button is currently being tested on the menu instead of having a button
			function(){
				var fs = {
					button: $('<div class="fullscreen-button">').button({icons: {primary: 'ui-icon-arrow-4-diag'}, text: false, label: 'Full size'}).prependTo('#gadget-head')
						.click(function(){
							$('#status-bar-outer, header').toggle();
							fs.handlers[fs.i++ % 2]();
							$('body').triggerHandler('layout');
						}),
					handlers: [
						function() {
							$('#main').addClass('fullsize');
							//fs.button('option', 'icons', {primary: 'ui-icon-arrowthick-2-ne-sw'});
							fs.button.button('option', 'icons', {primary: 'ui-icon-arrow-2-ne-sw'});
						},
						function() {
							console.log('2');
							$('#main').removeClass('fullsize');
							fs.button.button('option', 'icons', {primary: 'ui-icon-arrow-4-diag'});
						}
					],
					i: 0
				}
			},
			*/
			function(){
				require(['tool-buttons/clear', 'tool-buttons/fullmap', 'tool-buttons/undo', 'tool-buttons/redo', 'tool-buttons/zoomin', 'tool-buttons/zoomout', 'tool-buttons/drag_pan', 'tool-buttons/drag_zoom', 'tool-buttons/select', 'tool-buttons/vertical', 'tool-buttons/goto_marker', 'tool-buttons/print'], function() {
					$('#toolbar').toolbar({
						tools: [
							['clear', 'full-map'],
							['undo', 'redo'],
							['zoom-in', 'zoom-out'],
							['drag-pan', 'drag-zoom', 'select', 'vertical'],
							['goto-marker'],
							['print']],
						tooltips: true
					})
				})
			},
			function(){
				require(['tool-buttons/layers'], function() {
					$('#toolbar-right').toolbar({
						tools: [
							['layers']
						],
						tooltips: true
					})
				})
			},
			function(){
				require(['menu_pane', 'layer-list'], function() {
					$('#layer-list').layerList();
					$('#layer-list-pane').menuPane({
						noWidth: true,
						align: 'right',
						owner: $('.button.layers')
					})
				})
			},
			function(){
				$('#time-navigator').timeNavigator().hide();
			},
			function(){
				require(['animation-controls'], function() {
					var states = Settings.get('dialogue-states', {});
					$('body').animationControls({state: states['controls']});
				})
			},
			function(){
				// on-demand dialogue instantiation
				require(['view-dialogue', 'cities', 'legends', './time_series', './big_title'], function() {
					$.each({
							probe:         { title: 'Probe'},
							meteograms:    { title: 'Meteograms', options: Settings.get('meteograms-list', {products: ['10d_epsgram_2t'] })},
							legends:       { options: {show_zoom_buttons: true}},
							cities:        { title: 'City Finder'},
							info:          { widget: 'bigTitle'},
							'time-series': { title: 'Time Series', widget: 'chartTimeSeries'}
						},
						$.viewDialogue
					)
				})
			}
		]
		var i = -1;
		(function next(){
			var fn = fns[++i];
			fn && setTimeout(function(){
				fn()
				next()
			}, 10)
		})()

		$(document).productManager().shortcuts({
			shortcuts: [{
				key: $.ui.keyCode.UP,
				signal: 'next-base-time'
			},
			{
				key: $.ui.keyCode.DOWN,
				signal: 'prev-base-time'
			},
			{
				key: $.ui.keyCode.LEFT,
				signal: 'prev-step'
			},
			{
				key: $.ui.keyCode.RIGHT,
				signal: 'next-step'
			},
			{
				key: $.ui.keyCode.HOME,
				signal: 'first-step'
			},
			{
				key: $.ui.keyCode.END,
				signal: 'last-step'
			},
			{
				key: $.ui.keyCode.ESCAPE,
				signal: 'cancel'
			},
			{
				key: 52, // '4'
				callback: function () {
					open_dialogue('projection')
				}
			},
			{
				key: 53, // '5'
				callback: function () {
					open_dialogue('product')
				}
			},
			{
				key: 54, // '6'
				signal: 'open-layer-thumbnail-dialogue'
			},
			{
				key: $.ui.keyCode.NUMPAD_ADD,
				signal: 'tool-zoom-in'
			},
			{
				key: $.ui.keyCode.NUMPAD_SUBTRACT,
				signal: 'tool-zoom-out'
			},
			{
				key: $.ui.keyCode.COMMA,
				signal: 'animation-speed-down'
			},
			{
				key: $.ui.keyCode.PERIOD,
				signal: 'animation-speed-up'
			},
			{
				key: 51, // '#' key
				callback: function() { // '3'
					require(['chart/plugins/timers'], function(plugin) {
						var chart = $.fn.chart && $('.chart').chart('instance') || ($.fn.basicChart && $('.basic').basicChart('instance'));
						if(chart && chart.add_plugin('Timers', plugin)){
							require(['notify'], function() {
								$.notify({id: 1, kind: 'ok', story: 'ok', message: 'Calltree timers are now enabled<br/>Subsequent requests will have timer information available.'});
							});
						}else{
							Bus().send('open-calltree');
						}
					});
				}
			},
			{
				key: 61, // '=' key
				signal: 'show-timers'
			},
			{
				key: 187, // '=' key (webkit)
				signal: 'show-timers'
			},
			{
				key: 70, // 'f'
				signal: 'fullscreen'
			},
			{
				key: 80, // 'p'
				signal: 'presentation'
			},
			{
				key: 85, // 'u'
				signal: 'undo-key-press'
			},
			{
				key: 82, // 'r'
				signal: 'redo-key-press'
			}]
		});

		Reporter();

		Bus()
			.listen('multigrams-list-changed', function (_, msg) {
				Settings.set('meteograms-list', msg);
				$.logMessage('Meteogram List updated');
			})
			.listen('menu-help-help-select', function (_, msg) {
				window.open(ECMWF.options.settings.eccharts_help);
			})
			.listen('menu-help-preferences-select', function (_, msg) {
				require('preferences') && $(window).preferences();
			})
			.listen('menu-go-dashboard-select', function (_, msg) {
				location.href = ECMWF.options.site.dashboard;
			})
			.listen('chart-content-update', function (_, msg) {
				msg.changed.get('all') && chart.save(msg);
			})
			.listen('dialogue-state-changed', function (_, msg) {
				var pref = Settings.get('dialogue-states', {});
				pref[msg.name] = msg;
				Settings.set('dialogue-states', pref);
			})
			.listen('latlon-location-select', function (event, msg) {
				if(msg.from !== 'init'){
					Settings.set('last-probe-location', msg);
				}
				$.logMessage($.formatGeoLocation(msg) + ' ' + (msg.title || ''));
			})
			.listen('presentation', function () {
				$('.no-presentation').toggle();
				$('body').triggerHandler('layout');
			})
			.listen('workspace-select', function (_, workspace) {
				$.logMessage('Switched to workspace: ' + workspace.title);
				$('#chart').chart('setState', Settings.get('last-product'));
			});

		var loc = Settings.get('last-probe-location', null);
		if (loc) {
			setTimeout(function () {
				loc.from = 'init';
				Bus().send('latlon-location-select', loc);
			},
			500);
		}

		if(false && old_template){
			$('body').container({
				layout: 'border',
				north: $.extend($('.header-bar, #content-heading, #menu-bar, #page-wrapper > header'), {autoHeight: true}), // TODO move template specifics to config
				center: $(ECMWF.options.settings.content || '#content'),
				south: $('#status-bar')
			});
		}else{
			// use a custom layout for now until we know what is needed
			$('body').container({
				layout: function() {
					if(__BOOTSTRAP__)
						return {
							layout: function(size) {
								var elem = $('body')
								size = {width: elem.width(), height: elem.height() - 70};
								elem.children().content().each(function(){}).triggerHandler('layout', size);
								$('#gadget').triggerHandler('layout', size);
							}
						}
					else
						// new style for existing www page
						return {
							layout: function(size) {
								var bheight = 70;

								if(!$('header').is(':visible')) bheight -= 47
								if(!$('#status-bar-outer').is(':visible')) bheight -= 32

								$('#gadget').height($('body').height() - bheight)
								$('#gadget-content').height($('body').height() - bheight - 33)

								var elem = $('body')
								size = {width: elem.width(), height: elem.height() - bheight - 33};
								elem.children().content().each(function(){}).triggerHandler('layout', size);
								$('#chart').triggerHandler('layout', size);
								$('#time-navigator .time-nav').triggerHandler('layout', size);
							}
						}
				},
				north: $.extend($('.header-bar, #content-heading, #menu-bar, #page-wrapper > header'), {autoHeight: true}), // TODO move template specifics to config
				center: $(ECMWF.options.settings.content || '#content'),
				south: $('#status-bar')
			});
		}

		if(false && old_template){
		$('#gadget').container({
			layout: 'border',
			north: $('#gadget-head'),
			center: $('#gadget-content'),
			south: $('#time-navigator')
		});
		}

		$.fn.focusable();

		$('#ajax-loader').ajaxIndicator();

		setTimeout(function(){
			$('#time-navigator').show().animate({opacity: 1}, function(){
				$('#time-navigator').find('> .time-nav').triggerHandler('layout');
			});
		}, 500);

		function open_dialogue(kind){
			self.dialogues = self.dialogues || {}
			require(['thumbnail-dialogue/2'], function(Dialogue){
				self.dialogues[kind] = self.dialogues[kind] ? self.dialogues[kind].open() : new Dialogue({kind: kind})
			});
		}

		var chart;
		function load_chart(done){

			if (ECMWF.request.widget) {

				Ajaxqueue({
					url: ECMWF.options.ajax.backend.get_widget,
					json: {name: ECMWF.request.widget},
					success: function (result) {
						done(new dashboardChartDelegate(result));
					},
					error: function (result) {
					}
				});
			}
			else if (ECMWF.request.product) {
				done(new presetChartDelegate());
			} else {
				done(new chartDelegate());
			}
		}

		function chartDelegate() {

			this.options = {
				projection: (ECMWF.request.projection || 'europe'),
				use_outline: true,
				plugins: [resize]
			};

			this.save = function (msg) {
				Settings.set('last-product', msg.product.get_save_state());
			}

			this.create = function () {
				this.options.product = Settings.get('last-product', 'wind');
				return $('#chart').chart($.extend(this.options, {
					title: $('#chart-title')
				}));
			}
		}

		function presetChartDelegate() {

			this.options = {
				product: ECMWF.request.product,
				projection: (ECMWF.request.projection || 'europe'),
				plugins: [resize]
			};

			this.save = $.noop; // not savable

			this.create = function () {
				console.log('presetChartDelegate: product=', this.options.product);
				return $('#chart').chart($.extend(this.options, {
					title: $('#chart-title')
				}));
			}
		}

		function dashboardChartDelegate(widget) {

			ECMWF.request.widget = widget;

			this._title = widget.title;
			console.log('dashboardChartDelegate: widget.data:');
			console.log(widget.data);

			this.options = {
				product: widget.data.product,
				projection: widget.data.projection,
				plugins: [resize]
			};

			this.save = function (msg) {
				if (Settings.get('auto-save-widgets', false)) {
					widget.data.product = msg.product.save();
					Ajaxqueue({
						priority: 'very-high',
						url: ECMWF.options.ajax.backend.save_widget,
						json: widget,
						logErrors: 'Save product',
						success: function (result) {
							console.log('done. ', result);
						}
					});
				}
			}

			this.create = function () {
				console.log('dashboardChartDelegate.create: product=', this.options.product);
				var c = $('#chart').chart(this.options);
				$('#gadget').triggerHandler('layout');
				return c;
			}
		}
	})
})
});
